<?xml version="1.0" encoding="UTF-8"?>
<xs:schema xmlns:xs="http://www.w3.org/2001/XMLSchema" elementFormDefault="qualified">

	<xs:group name="GlobalPlugins">
		<xs:all>
			<xs:element name="Field" type="Field"  						minOccurs="0" 	maxOccurs="unbounded"/>
			<xs:element name="VectorField" type="cpmVectorField"  		minOccurs="0" 	maxOccurs="unbounded"/>
		</xs:all>
	</xs:group>
	
	<xs:complexType name="Field">
		<xs:complexContent>
			<xs:extension base="morphPlugin">
				<xs:annotation>
					<xs:appinfo>Container</xs:appinfo>
				</xs:annotation>
				<xs:all>
					<xs:element name="Diffusion" type="cpmDiffusion"  minOccurs="0" />
		<!-- 			<xs:element name="BoundaryConditions"  type="cpmPDEBoundaryConditions" minOccurs="0" /> -->
					<xs:element name="BoundaryValue" type="cpmPDEBoundaryValue" minOccurs="0" maxOccurs="unbounded" />
					<xs:element name="Reduction" type="cpmBoundary" minOccurs="0" />
		<!-- 			<xs:element name="Initial" minOccurs="0">
						<xs:group  ref="FieldInitPlugins" />
					</xs:element>-->
					<xs:element name="Data" type="cpmFieldData" minOccurs="0" />
					<xs:element name="TIFFReader" type="TIFFReaderField" minOccurs="0" />
					
				</xs:all>
				<xs:attribute name="symbol" type="cpmDoubleSymbolDef" use="required" />
				<xs:attribute name="value"	type="cpmMathExpression" use="required" />
					</xs:extension>
		</xs:complexContent>
	</xs:complexType>
	
	<xs:group  name="FieldInitPlugins">
		<xs:choice>
			<xs:element name="Data" type="cpmFieldData" />
		</xs:choice>
	</xs:group>
	
	<xs:complexType name="cpmDiffusion">
		<xs:annotation>
			<xs:documentation>Diffusion coefficient</xs:documentation>
		</xs:annotation>
		<xs:attribute name="rate" type="cpmMathExpression"/>
<!--   		<xs:attribute name="unit" type="cpmDiffusionUnit" use="optional" />   -->
		<xs:attribute name="well-mixed" type="cpmBoolean" use="optional">
			<xs:annotation>
				<xs:documentation>Complete spatial mixing, while conserving mass.</xs:documentation>
			</xs:annotation>
		</xs:attribute>
	</xs:complexType>
	
	<xs:simpleType name="cpmDiffusionUnit">
		<xs:annotation>
			<xs:documentation>Unit of diffusion constant</xs:documentation>
		</xs:annotation>
        <xs:restriction base="cpmString">
				<xs:enumeration value="m²/s"/>
				<xs:enumeration value="mm²/s"/>
				<xs:enumeration value="µm²/s"/>
        </xs:restriction>
    </xs:simpleType>

	<xs:complexType name="cpmPDEBoundaryConditions">
		<xs:all>
			<xs:element name="Condition"		maxOccurs="unbounded">
				<xs:complexType>
					<xs:attribute name="boundary" use="required" type="cpmBoundaryRef" />
					<xs:attribute name="value" use="required" type="cpmDouble" />
				</xs:complexType>
			</xs:element>
		</xs:all>
	</xs:complexType>
	
	
	
	<xs:complexType name="cpmPDEBoundaryValue">
		<xs:attribute name="boundary" use="required" type="cpmBoundaryRef"/>
		<xs:attribute name="value" use="required" type="cpmMathExpression" />
		<xs:attribute name="type" use="optional" type="morphBoundaryValueTypes" default="value" />
	</xs:complexType>

	<xs:complexType name="cpmFieldData">
		<xs:simpleContent>
			<xs:extension base="xs:normalizedString">
				<xs:attribute name="filename" use="optional" type="cpmSystemFile" />
				<xs:attribute name="encoding" use="required" type="morphDataEncoding" default="base64" />
				<xs:attribute name="word-size" use="optional" type="xs:integer" default="4" />
				<xs:attribute name="index" use="optional" type="xs:integer" default="0" />
			</xs:extension>
		</xs:simpleContent>
	</xs:complexType>
	
	<xs:simpleType name="morphDataEncoding" >
		<xs:restriction base="xs:token">
			<xs:enumeration value="ascii"/>
			<xs:enumeration value="base64"/>
			<xs:enumeration value="binary"/>
			<xs:enumeration value="tiff"/>
		</xs:restriction>
	</xs:simpleType>
	
	<xs:complexType name="cpmVectorField">
		<xs:complexContent>
			<xs:extension base="morphPlugin">
				<xs:annotation>
					<xs:appinfo>Container</xs:appinfo>
				</xs:annotation>
				<xs:all>
					<xs:element name="BoundaryValue" type="cpmVectorBoundaryValue" minOccurs="0" maxOccurs="unbounded" />
					<xs:element name="Reduction" type="cpmBoundary" minOccurs="0" />
		<!-- 			<xs:element name="Initial" minOccurs="0">
						<xs:group  ref="FieldInitPlugins" />
					</xs:element>-->
					<xs:element name="Data" type="cpmFieldData" minOccurs="0" />
					
				</xs:all>
				<xs:attribute name="symbol" type="cpmVectorSymbolDef" use="required" />
				<xs:attribute name="value"	type="cpmVectorMathExpression" use="required" />
			</xs:extension>
		</xs:complexContent>
	</xs:complexType>
	
	<xs:complexType name="cpmVectorBoundaryValue">
		<xs:attribute name="boundary" use="required" type="cpmBoundaryRef"/>
		<xs:attribute name="value" use="required" type="cpmVectorMathExpression" />
	</xs:complexType>
	
</xs:schema>
